#include<stdlib.h> //these are libraries(see explanation below
#include"allegro.h"
#include<math.h>
#include <stdio.h>
#include <conio.h>
#include <winalleg.h>
#include <time.h>

/*
symfaces.c presents bitmap images of faces and collects ratings of symmetry from the user.
*/

//definitions
#define TRIAL 48   //TRIAL defines the number of trials - I haven't figured out a good way to make this a changeable
                  //parameter
#define USED 1    //USED and UNUSED are used to randomize trial order
#define UNUSED -1
#define LEFT 1
#define RIGHT 2
#define UP 3
#define DOWN 4
#define PORTDUR 10  //duration of port codes before they are zeroed out
#define LOW 0
#define MEDIUM 1
#define HIGH 2
#define PICDUR 500
#define TIMEOUTDUR 3000
#define TRIAL_ITI 1000
#define ITIRANGE 1000
#define ITI 1000
#define SOA1 100
#define SOA2 1200
#define TARGETDURATION 500
#define ARROWDURATION 500
#define FIXSIZE 10
#define PORTDUR 10

// Global variables
volatile int counter;
int trialrt[TRIAL]; 
int resptime[TRIAL]; //time of the response on trial TRIAL
int primetaskrt[TRIAL];
int primetaskresptime[TRIAL];
int primetaskresponse[TRIAL];

// Function prototypes
int trial(BITMAP *bmp, int trialnum, int arrowpoints, int tonepitch, int SOA);
int evalprimaryresponse(int response, int tonefreq);
int evalsecondaryresponse(int response, int direction);
void wrongfeedback();
void secondarywrongfeedback();
void groupingfeedback();
int evalgrouping(int responsetime, int primetaskresponsetime, int soa);
/* prototype (function typedef) for DLL function Inp32: */
     typedef short _stdcall (*inpfuncPtr)(short portaddr);
     typedef void _stdcall (*oupfuncPtr)(short portaddr, short datum);
//**********************************************************************

void my_timer_handler() 
{ 
  counter++; 
}
END_OF_FUNCTION(my_timer_handler) 


main()
{

  int i,j, temp;  //counters

  int TRIALTYPES = 24,//the number of different kinds of trials
    TRIALS = TRIAL,usedarray[TRIAL],trialtype[TRIAL], trial_iti[TRIAL], trialrep[TRIAL], trialtarg[TRIAL], trialsoa[TRIAL], trialdirection[TRIAL],primaryrespcorrect[TRIAL],secondaryrespcorrect[TRIAL],taskgrouping[TRIAL],fixx, fixy, z;

  short px; 

  //for writing to printer port
     HINSTANCE hLib;
     inpfuncPtr inp32;
     oupfuncPtr oup32;

  FILE *fp; FILE *fp2;   FONT *f1;
  BITMAP *buffer;


 //initialize the allegro library and set various parameters
 allegro_init();
  set_color_depth(16);
  set_gfx_mode(GFX_AUTODETECT, 1280, 1024, 0, 0);
  install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL);
  install_keyboard();
  install_mouse();
  install_timer();
 LOCK_VARIABLE(counter);
  LOCK_FUNCTION(my_timer_handler);
  install_int(my_timer_handler, 1);
  //END OF INITIALIZING ALLEGRO AND SETTING PARAMETERS****************************************
 /* Load the library to write to printer port*/
     hLib = LoadLibrary("inpout32.dll");

     if (hLib == NULL) {
          printf("LoadLibrary Failed.\n");
          return -1;
     }

     /* get the address of the function */

     inp32 = (inpfuncPtr) GetProcAddress(hLib, "Inp32");

     if (inp32 == NULL) {
          printf("GetProcAddress for Inp32 Failed.\n");
          return -1;
     }


     oup32 = (oupfuncPtr) GetProcAddress(hLib, "Out32");

     if (oup32 == NULL) {
          printf("GetProcAddress for Oup32 Failed.\n");
          return -1;
     }

     //end of loading library for writing to printer port
/***************************************************************/


  buffer = create_bitmap(1280,1024);          
  clear_to_color(buffer, makecol(0,0,0));    
  fp = fopen("prp_log.txt","a");    
   fixx = SCREEN_W/2; fixy = SCREEN_H/2;


 //randomize trial order for the combined trials 
  for(i = 0; i < TRIALS; i++)
    { 
      usedarray[i] = UNUSED;
    }
  unsigned int seed = time(NULL);
  srand(seed);
  rand();

 for(i = 0; i < TRIALS; i++)
    { do
	{ temp = ((int)TRIALS * rand()/(RAND_MAX + 1.0));
	} while(usedarray[temp] == USED);
      usedarray[temp] = USED; // don't use this value of temp again
      trialtype[i] = temp; 
    
    }          

 for(j=0;j<TRIALS;j++)//generate a random inter-trial interval
    {
       trial_iti[j] = ((int)ITIRANGE*rand()/(RAND_MAX+1.0)+ITI);
    
    }
 //END OF RANDOMIZING TRIAL ORDER FOR COMBINED TRIALS*********************

 //put in a pause until a go signal
 while(1)//while(1) holds the CPU until the condition of the while loop is met
   {
     if(keypressed())//the condition of the while loop is that any key is pressed
       {
	 break;//when that condition is met, break the loop
       }
   }
 rest(1000);

 //DO THE TRIALS
  for(i=0;i<TRIALS;i++)
     {
       	rest(trial_iti[i]);//put in the random inter-trial interval

       if(key[KEY_ESC]) break;//always give yourself a way to kill the program
       if(key[KEY_P])//and pause the program
	  {
       while(1)
	 {if(key[KEY_R]) break;//and resume once you have paused
	 }
	  }
       
        circlefill(screen,fixx,fixy,FIXSIZE,makecol(255,255,255));
       if(trialtype[i]<(TRIALS/TRIALTYPES))
	 {
	   trialrep[i]=trial(screen, i, LEFT, HIGH, SOA1);
	   trialtarg[i]=HIGH; trialsoa[i]=SOA1; trialdirection[i]=LEFT;
	 }       
       else if(trialtype[i]<2*(TRIALS/TRIALTYPES))
	 {
	   trialrep[i]=trial(screen, i, LEFT, LOW, SOA1);
            trialtarg[i]=LOW; trialsoa[i]=SOA1;trialdirection[i]=LEFT;
	 }
       else if(trialtype[i]<3*(TRIALS/TRIALTYPES))
	 {
	   trialrep[i]=trial(screen, i, LEFT, HIGH, SOA2);
            trialtarg[i]=HIGH; trialsoa[i]=SOA2;trialdirection[i]=LEFT;
	 }   
       else if(trialtype[i]<4*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, LEFT, LOW, SOA2); 
	    trialtarg[i]=LOW;   trialsoa[i]=SOA2; trialdirection[i]=LEFT;
	 } 
       else if(trialtype[i]<5*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, RIGHT, HIGH, SOA1); 
	    trialtarg[i]=HIGH; trialsoa[i]=SOA1; trialdirection[i]=RIGHT;    
	 } 
       else if(trialtype[i]<6*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, RIGHT, LOW, SOA1); 
	    trialtarg[i]=LOW;  trialsoa[i]=SOA1;  trialdirection[i]=RIGHT;  
	 } 
       else if(trialtype[i]<7*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, RIGHT, HIGH, SOA2); 
	    trialtarg[i]=HIGH;  trialsoa[i]=SOA2;  trialdirection[i]=RIGHT;  
	 } 
       else if(trialtype[i]<8*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, RIGHT, LOW, SOA2); 
	    trialtarg[i]=LOW;  trialsoa[i]=SOA2;  trialdirection[i]=RIGHT;  
	 } 
      else if(trialtype[i]<9*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, RIGHT, MEDIUM, SOA1); 
	    trialtarg[i]=MEDIUM; trialsoa[i]=SOA1; trialdirection[i]=RIGHT;    
	 } 
       else if(trialtype[i]<10*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, LEFT, MEDIUM, SOA1); 
	    trialtarg[i]=MEDIUM;  trialsoa[i]=SOA1;trialdirection[i]=LEFT;  
	 } 
       else if(trialtype[i]<11*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, RIGHT, MEDIUM, SOA2); 
	    trialtarg[i]=MEDIUM;  trialsoa[i]=SOA2; trialdirection[i]=RIGHT; 
	 } 
       else if(trialtype[i]<12*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, LEFT, MEDIUM, SOA2); 
	    trialtarg[i]=MEDIUM;  trialsoa[i]=SOA2; trialdirection[i]=LEFT; 
	 } 
      if(trialtype[i]<(13*TRIALS/TRIALTYPES))
	 {
	   trialrep[i]=trial(screen, i, DOWN, HIGH, SOA1);
	   trialtarg[i]=HIGH; trialsoa[i]=SOA1; trialdirection[i]=LEFT;
	 }       
       else if(trialtype[i]<14*(TRIALS/TRIALTYPES))
	 {
	   trialrep[i]=trial(screen, i, DOWN, LOW, SOA1);
            trialtarg[i]=LOW; trialsoa[i]=SOA1;trialdirection[i]=LEFT;
	 }
       else if(trialtype[i]<15*(TRIALS/TRIALTYPES))
	 {
	   trialrep[i]=trial(screen, i, DOWN, HIGH, SOA2);
            trialtarg[i]=HIGH; trialsoa[i]=SOA2;trialdirection[i]=LEFT;
	 }   
       else if(trialtype[i]<16*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, DOWN, LOW, SOA2); 
	    trialtarg[i]=LOW;   trialsoa[i]=SOA2; trialdirection[i]=LEFT;
	 } 
       else if(trialtype[i]<17*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, UP, HIGH, SOA1); 
	    trialtarg[i]=HIGH; trialsoa[i]=SOA1; trialdirection[i]=RIGHT;    
	 } 
       else if(trialtype[i]<18*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, UP, LOW, SOA1); 
	    trialtarg[i]=LOW;  trialsoa[i]=SOA1;  trialdirection[i]=RIGHT;  
	 } 
       else if(trialtype[i]<19*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, UP, HIGH, SOA2); 
	    trialtarg[i]=HIGH;  trialsoa[i]=SOA2;  trialdirection[i]=RIGHT;  
	 } 
       else if(trialtype[i]<20*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, UP, LOW, SOA2); 
	    trialtarg[i]=LOW;  trialsoa[i]=SOA2;  trialdirection[i]=RIGHT;  
	 } 
      else if(trialtype[i]<21*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, UP, MEDIUM, SOA1); 
	    trialtarg[i]=MEDIUM; trialsoa[i]=SOA1; trialdirection[i]=RIGHT;    
	 } 
       else if(trialtype[i]<22*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, DOWN, MEDIUM, SOA1); 
	    trialtarg[i]=MEDIUM;  trialsoa[i]=SOA1;trialdirection[i]=LEFT;  
	 } 
       else if(trialtype[i]<23*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, UP, MEDIUM, SOA2); 
	    trialtarg[i]=MEDIUM;  trialsoa[i]=SOA2; trialdirection[i]=RIGHT; 
	 } 
       else if(trialtype[i]<24*(TRIALS/TRIALTYPES))
	 {	  
	   trialrep[i]=trial(screen, i, DOWN, MEDIUM, SOA2); 
	    trialtarg[i]=MEDIUM;  trialsoa[i]=SOA2; trialdirection[i]=LEFT; 
	 } 
       primaryrespcorrect[i]=evalprimaryresponse(trialrep[i],trialtarg[i]);
       secondaryrespcorrect[i]=evalsecondaryresponse(primetaskresponse[i] , trialdirection[i]);
       taskgrouping[i]=evalgrouping(trialrt[i],primetaskrt[i],trialsoa[i]);
        if(primaryrespcorrect[i]==0){wrongfeedback();}
	if(secondaryrespcorrect[i]==0){secondarywrongfeedback();}
	if(taskgrouping[i]==1){groupingfeedback();}
     }//END OF DO THE TRIALS
 
  //save the data
 fprintf(fp,"trial\ttone\tdirection\tSOA\tprimeresponse\tprimert\tprimecorrect\tsecondaryresp\tsecondaryrt\tsecondarycorrect\tgrouping\n");//put a header on the log file
 
  for(i=0;i<TRIALS;i++)
    { 
      fprintf(fp,"%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\t%i\n",i,trialtarg[i],trialdirection[i],trialsoa[i],trialrep[i],trialrt[i],primaryrespcorrect[i],primetaskresponse[i],primetaskrt[i],secondaryrespcorrect[i],taskgrouping[i]); 
    }
  //mislabeled variables for secondary task as "primary", too lazy to fix it

FreeLibrary(hLib);
fclose(fp);
  allegro_exit(); //this should take care of all stim-related memory leaks
  return(0); 

}
END_OF_MAIN();//****************************************************

int trial(BITMAP *bmp, int trialnum, int arrowpoints, int tonepitch, int SOA)
{

  int begin_timeout, tone_timer, targetbegintime, response=0, targetcolor, fixx, fixy, z, portimer, arrowbegintime, response1trigger, response2trigger;
  short arrowpx, tonepx, px, respx; 
  BITMAP  *arrow; 
  SAMPLE *tone;

 HINSTANCE hLib;
     inpfuncPtr inp32;
     oupfuncPtr oup32;
  /* Load the library */
     hLib = LoadLibrary("inpout32.dll");

  oup32 = (oupfuncPtr) GetProcAddress(hLib, "Out32");

  arrow = create_bitmap(SCREEN_W, SCREEN_H);
  clear(arrow);
  targetcolor = makecol(255,255,255);
  fixx = SCREEN_W/2; fixy = SCREEN_H/2;
  response1trigger = 0; response2trigger = 0;
  z = 0x378; px=0x00;
 //LOAD ALL THE STIMULI**********************************************************************
  //***************************************************************************************
  if(tonepitch ==HIGH)
    {
      tone = load_wav("a6_1760.wav"); tonepx = 0x01;
    }
  else if(tonepitch ==MEDIUM)
    {
      tone = load_wav("a4_440.wav");tonepx = 0x02;
    }
  else if(tonepitch ==LOW)
    {
      tone = load_wav("a3_220.wav");tonepx = 0x03;
    }

  if(arrowpoints==LEFT)
    {
      rectfill(arrow, fixx-30, fixy-10, fixx+30, fixy+10, targetcolor);
      triangle(arrow, fixx-30, fixy-20, fixx-50, fixy, fixx-30, fixy+20, targetcolor);
      if(SOA==SOA1){arrowpx = 0x04;}
      else if(SOA==SOA2){arrowpx = 0x05;}
    }
    else if(arrowpoints==RIGHT)
    {
      rectfill(arrow, fixx-30, fixy-10, fixx+30, fixy+10, targetcolor);
      triangle(arrow, fixx+30, fixy-20, fixx+50, fixy, fixx+30, fixy+20, targetcolor);
            if(SOA==SOA1){arrowpx = 0x06;}
      else if(SOA==SOA2){arrowpx = 0x07;}
    }
    else if(arrowpoints==UP)
    {
      rectfill(arrow, fixx-10, fixy-30, fixx+10, fixy+30, targetcolor);
      triangle(arrow, fixx+20, fixy-30, fixx, fixy-50, fixx-20, fixy-30, targetcolor);
            if(SOA==SOA1){arrowpx = 0x08;}
      else if(SOA==SOA2){arrowpx = 0x09;}
    }
    else if(arrowpoints==DOWN)
    {
     rectfill(arrow, fixx-10, fixy-30, fixx+10, fixy+30, targetcolor);
      triangle(arrow, fixx+20, fixy+30, fixx, fixy+50, fixx-20, fixy+30, targetcolor);
            if(SOA==SOA1){arrowpx = 0x10;}
      else if(SOA==SOA2){arrowpx = 0x11;}
    }
 circlefill(screen,fixx,fixy,FIXSIZE,makecol(255,255,255));

 //stimulus port codes: 1 = high tone, 2 = medium, 3 = low, 4 = left arrow SOA1, 5 = left arrow SOA2
 //6 = right arrow SOA1, 7 = right arrow SOA2
  //END OF LOADING ALL THE STIMULI*************************************************
  //*****************************************************************************
      
 play_sample(tone,255,127,1000,0);
  //send signal to port that tone has been presented
     (oup32)(z,tonepx);
     portimer = counter;
     while(counter-portimer<PORTDUR){}
     (oup32)(z,px);
     //*******************************************
 tone_timer = counter;targetbegintime = counter;
  while(counter-tone_timer<SOA)
     {
      	if(key[KEY_X]) 
	  {
	    while(response1trigger==0){respx = 0x40; (oup32)(z,respx);response1trigger=1;break;}
	      response = LEFT; resptime[trialnum]=counter; 
	      trialrt[trialnum]=resptime[trialnum]-targetbegintime;
	    }
      if(key[KEY_STOP]) 
             {
	       while(response1trigger==0){respx = 0x80; (oup32)(z,respx);response1trigger=1;break;} 
	       response = RIGHT;  resptime[trialnum]=counter;
	       trialrt[trialnum]= resptime[trialnum]-targetbegintime;
	     }
       if(key[KEY_Z])
	 {while(response2trigger==0){respx = 0x50; (oup32)(z,respx); response2trigger=1;}
	   primetaskresponse[trialnum]=LEFT;primetaskresptime[trialnum]=counter;
	   primetaskrt[trialnum]=1;
	 }
       if(key[KEY_SLASH])
	 {while(response2trigger==0){respx = 0x60; (oup32)(z,respx); response2trigger=1;}
	   primetaskresponse[trialnum]=RIGHT;primetaskresptime[trialnum]=counter;
	   primetaskrt[trialnum]=1;//early response, before arrow target
	 }
     }


 

  
    vsync;
   blit(arrow,screen,0,0,0,0,screen->w,screen->h);
  //send signal to port that arrow has been presented
  z=0x378;
     arrowpx=0x17;
     (oup32)(z,arrowpx);
     portimer = counter;
     while(counter-portimer<PORTDUR){}
     px=0x00;
     (oup32)(z,arrowpx);
     //*******************************************
	 arrowbegintime=counter;
  // circlefill(screen, 640, 512, 30, makecol(255,255,255));
  while(counter-arrowbegintime<ARROWDURATION)
    {
      	if(key[KEY_X]) 
	  {while(response1trigger==0){respx = 0x40; (oup32)(z,respx); response1trigger=1;break;}
	      response = LEFT; resptime[trialnum]=counter; 
	      trialrt[trialnum]=resptime[trialnum]-targetbegintime;
	    }
      if(key[KEY_STOP]) 
	{while(response1trigger==0){respx = 0x80; (oup32)(z,respx);response1trigger=1;break;} 
	       response = RIGHT;  resptime[trialnum]=counter;
	       trialrt[trialnum]= resptime[trialnum]-targetbegintime;
	     }
      if(key[KEY_Z])
	{while(response2trigger==0){respx = 0x50; (oup32)(z,respx);response2trigger=1;break;}
	   primetaskresponse[trialnum]=LEFT;primetaskresptime[trialnum]=counter;
	   primetaskrt[trialnum]=primetaskresptime[trialnum]-arrowbegintime;
	 }
        if(key[KEY_SLASH])
	  {while(response2trigger==0){respx = 0x60; (oup32)(z,respx);response2trigger=1;break;}
	   primetaskresponse[trialnum]=RIGHT;primetaskresptime[trialnum]=counter;
	   primetaskrt[trialnum]=primetaskresptime[trialnum]-arrowbegintime;
	 }

    }
  clear(screen);
   circlefill(screen,fixx,fixy,FIXSIZE,makecol(255,255,255));

  begin_timeout = counter;
    while(counter-begin_timeout<TIMEOUTDUR)
      {
	if(key[KEY_X]) 
	  {while(response1trigger==0){respx = 0x40; (oup32)(z,respx);response1trigger=1;break;} 
	      response = LEFT; resptime[trialnum]=counter; 
	      trialrt[trialnum]=resptime[trialnum]-targetbegintime;
	    }
      if(key[KEY_STOP]) 
	{while(response1trigger==0){respx = 0x80; (oup32)(z,respx);response1trigger=1;break;} 
	       response = RIGHT;  resptime[trialnum]=counter;
	       trialrt[trialnum]= resptime[trialnum]-targetbegintime;
	     }
      if(key[KEY_Z])
	{while(response2trigger==0){respx = 0x50; (oup32)(z,respx);response2trigger=1;break;}
	   primetaskresponse[trialnum]=LEFT;primetaskresptime[trialnum]=counter;
	   primetaskrt[trialnum]=primetaskresptime[trialnum]-arrowbegintime;
	 }
        if(key[KEY_SLASH])
	  {while(response2trigger==0){respx = 0x60; (oup32)(z,respx);response2trigger=1;break;}
	   primetaskresponse[trialnum]=RIGHT;primetaskresptime[trialnum]=counter;
	   primetaskrt[trialnum]=primetaskresptime[trialnum]-arrowbegintime;
	 }
      }
      
    destroy_bitmap(arrow);
    //fclose(tone);
  return(response);
}//END OF TRIAL************************************************************
int evalprimaryresponse(int response, int tonefreq)
{
  int primarycorrect;

  if(tonefreq==HIGH)
    {
      if(response==LEFT)
	{primarycorrect=1;}
      else primarycorrect=0;
    }
  else if(tonefreq==LOW)
    {
      if(response==RIGHT)
	{primarycorrect=1;}
      else primarycorrect=0;
    }
  else if(tonefreq==MEDIUM)
    {
      if(response==0)
		{primarycorrect=1;}
      else primarycorrect=0;
    }



  return(primarycorrect);
}
int evalsecondaryresponse(int response, int direction)
{
  int secondarycorrect;


  if(response==direction)
    {secondarycorrect=1;}
  else if(direction==UP)
    {if(response==RIGHT)
	{secondarycorrect=1;}
      else secondarycorrect=0;
    }
  else if(direction==DOWN)
    {if(response==LEFT)
	{secondarycorrect=1;}
      else secondarycorrect=0;
    }
  else secondarycorrect=0;


  return(secondarycorrect);
}
void wrongfeedback()
{
  FONT *f1;
 f1 = load_font("unifont.dat", NULL, NULL);
   if (!f1) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
      allegro_message("Cannot find unifont.dat in current directory.\n");
     
   }

  clear(screen);
 textout_centre_ex(screen, f1,"ERROR. REMEMBER",SCREEN_W/2,SCREEN_H/2-20,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"X for HIGH, > for LOW!",SCREEN_W/2,SCREEN_H/2+20,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"No response for the MIDDLE tone!",SCREEN_W/2,SCREEN_H/2+50,makecol(255,255,255),makecol(0,0,0));
     rest(3000);
     clear(screen); 

}
void secondarywrongfeedback()
{
  FONT *f1;
 f1 = load_font("unifont.dat", NULL, NULL);
   if (!f1) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
      allegro_message("Cannot find unifont.dat in current directory.\n");
     
   }

  clear(screen);
 textout_centre_ex(screen, f1,"ERROR. REMEMBER",SCREEN_W/2,SCREEN_H/2-20,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"Z for LEFT OR DOWN ARROW",SCREEN_W/2,SCREEN_H/2+20,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"/ key for RIGHT OR UP ARROW",SCREEN_W/2,SCREEN_H/2+50,makecol(255,255,255),makecol(0,0,0));
     rest(3000);
     clear(screen); 

}
void groupingfeedback()
{
  FONT *f1;
 f1 = load_font("unifont.dat", NULL, NULL);
   if (!f1) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
      allegro_message("Cannot find unifont.dat in current directory.\n");
     
   }

  clear(screen);
 textout_centre_ex(screen, f1,"LOOKS LIKE YOU ARE HOLDING YOUR FIRST RESPONSE",SCREEN_W/2,SCREEN_H/2-20,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"UNTIL YOU ARE READY TO MAKE THE SECOND RESPONSE.",SCREEN_W/2,SCREEN_H/2+20,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"IT IS CRITICAL THAT YOU MAKE THE FIRST RESPONSE",SCREEN_W/2,SCREEN_H/2+50,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"AS EARLY AS POSSIBLE WITHOUT HOLDING IT AND THEN",SCREEN_W/2,SCREEN_H/2+80,makecol(255,255,255),makecol(0,0,0));
 textout_centre_ex(screen, f1,"MAKE THE SECOND RESPONSE",SCREEN_W/2,SCREEN_H/2+110,makecol(255,255,255),makecol(0,0,0));
     rest(3000);
     clear(screen); 

}
int evalgrouping(int responsetime, int primetaskresponsetime, int soa)
{
  int groupeval;
  if(responsetime>0)
    {
  if(primetaskresponsetime-responsetime<100)
    {groupeval = 1;
    }
  else groupeval = 0;
    }
  else groupeval = 0;

  return(groupeval);
}

